package {
	import flash.display.BitmapData;
	import flash.geom.Point;
	
	/**
	 * ...
	 * @author Volgogradetzzz
	 */
	public class TriangleRasterizer {
		
		public static function rasterizeTriangle(p1:Point, p2:Point, p3:Point, d1:Number, d2:Number, d3:Number, bd:BitmapData):void {
			var w:Number = p1.x;
			var h:Number = p1.y;
			
			if (p2.x > w) {
				w = p2.x;
			}
			
			if (p3.x > w) {
				w = p3.x;
			}
			
			if (p2.y > h) {
				h = p2.y;
			}
			
			if (p3.y > h) {
				h = p3.y;
			}
			
			efla(p1, p2, bd, d1, d2);
			efla(p2, p3, bd, d2, d3);
			efla(p3, p1, bd, d3, d1);
			
			var a:uint;
			var color:uint;
			
			var startX:int = -1;
			var startY:int = -1;
			
			var endX:int = -1;
			var endY:int = -1;
			
			var dCurr:Number;
			var dStart:Number;
			var dEnd:Number;
			var ratio:Number;
			
			for (var pixY:uint = 0; pixY < bd.height; pixY++) {
				startX = -1;
				startY = pixY;
				
				endX = -1;
				endY = pixY;
				
				for (var pixX:uint = 0; pixX < bd.width; pixX++) {
					color = bd.getPixel32(pixX, pixY);
					a = (color >> 24) & 0xFF;
					
					if (a == 255) {
						if (startX == -1) {
							startX = pixX;
							endX = pixX;
							
							dStart = FloatColorConverter.color24ToUnitFloat(color);
							dEnd = FloatColorConverter.color24ToUnitFloat(color);
						}else {
							endX = pixX;
							
							dEnd = FloatColorConverter.color24ToUnitFloat(color);
						}
					}
				}
				
				if (startX > -1) {
					for (var i:uint = startX; i <= endX; i++) {
						if (endX != startX) {
							ratio = (i - startX) / (endX - startX);
							dCurr = dStart + (dEnd - dStart) * ratio;
						}else {
							dCurr = dStart;
						}
						
						color = FloatColorConverter.unitFloatToColor24(dCurr);
						color |= (255 << 24);
						
						bd.setPixel32(i, pixY, color);
					}
				}
			}
		}
		
		private static function efla(start:Point, end:Point, bd:BitmapData, dStart:Number, dEnd:Number):void {
			var shortLen:int = end.y - start.y;
			var longLen:int = end.x - start.x;
			
			if((shortLen ^ (shortLen >> 31)) - (shortLen >> 31) > (longLen ^ (longLen >> 31)) - (longLen >> 31)) {
				shortLen ^= longLen;
				longLen ^= shortLen;
				shortLen ^= longLen;
				
				var yLonger:Boolean = true;
			}else{
				yLonger = false;
			}
			
			var inc:int = longLen < 0 ? -1 : 1;
			
			var multDiff:Number = longLen == 0 ? shortLen : shortLen / longLen;
			
			var len:Number = Math.sqrt((end.x - start.x) * (end.x - start.x) + (end.y - start.y) * (end.y - start.y));
			var currLen:Number;
			var ratio:Number;
			var dCurr:Number;
			var color:uint;
			
			if (yLonger) {
				for (var i:int = 0; i != longLen; i += inc) {
					currLen = Math.sqrt((i * multDiff) * (i * multDiff) + i * i);
					ratio = currLen / len;
					
					dCurr = dStart + (dEnd - dStart) * ratio;
					
					color = FloatColorConverter.unitFloatToColor24(dCurr);
					color |= (255 << 24);
					
					bd.setPixel32(Math.round(start.x + i * multDiff), Math.round(start.y + i), color);
				}
			} else {
				for (i = 0; i != longLen; i += inc) {
					currLen = Math.sqrt(i * i + (i * multDiff) * (i * multDiff));
					ratio = currLen / len;
					
					dCurr = dStart + (dEnd - dStart) * ratio;
					
					color = FloatColorConverter.unitFloatToColor24(dCurr);
					color |= (255 << 24);
					
					bd.setPixel32(Math.round(start.x + i), Math.round(start.y + i * multDiff), color);
				}
			}
		}
	}

}